#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fun>


#define TASK_BOMB		3202
#define MAXPLAYERS		32
#define TE_SPRITE                   17   
 
/* 
Server Restart in 60 seconds. 
English Version
Version 2.1
*/


new timer
new bool: countdownon 
new const attention [] = "sound/vox/attention.wav"
new const warn [] = "sound/vox/bizwarn.wav"
new const g_launch [] = "misc/server_restart/launch.mp3"
new const g_rocket [] = "misc/server_restart/rocket.wav"
new const g_siren [] = "misc/server_restart/siren.wav"

new g_synchud;

new g_shockwave;
new g_streak;
new g_fade;
new g_shake;
new g_hexplo;
new g_smoke;


public plugin_init() {
	register_plugin("Server Restart", "2.1", "Sula")
	register_clcmd("amx_restart","countdown",ADMIN_RCON,"Server Restart in 60 seconds") 
	register_clcmd("amx_testlaunch","countdown2",ADMIN_RCON,"Test Launch without restart") 
	
	// register_dictionary("server_restart.txt");
	
	g_synchud = CreateHudSyncObj();
	g_fade = get_user_msgid("ScreenFade");
	g_shake = get_user_msgid("ScreenShake");
}

public plugin_precache()
{
	precache_sound(g_launch)
	precache_sound(g_rocket)
	precache_sound(g_siren)
	precache_model("sprites/bflare.spr") 
	
	g_shockwave = precache_model("sprites/shockwave.spr");
	g_streak = precache_model("sprites/streak.spr");
	g_hexplo = precache_model("sprites/hexplo.spr");
	g_smoke = precache_model("sprites/black_smoke1.spr");

}

public screen()
{
	new players[32], inum
	get_players(players,inum,"ac")
	for(new i = 0 ;i < inum; ++i){	
		message_begin ( MSG_ONE_UNRELIABLE, get_user_msgid("ScreenShake"), {0,0,0}, players[i] )
		write_short (2<<13) // Amplitda
		write_short (4<<13) // Trvanie
		write_short (1<<15) // Frekvencia
		message_end ( )
		}
}

public shake_end()
{
	new players[32], inum
	get_players(players,inum,"ac")
	for(new i = 0 ;i < inum; ++i){	
		message_begin ( MSG_ONE_UNRELIABLE, get_user_msgid("ScreenShake"), {0,0,0}, players[i] )
		write_short (5<<13) // Amplitda
		write_short (6<<13) // Trvanie
		write_short (3<<15) // Frekvencia 
		message_end ( )
		}
}

public rocket_sound()
	client_cmd(0, "spk %s", g_rocket )

public launch_sound()
	client_cmd( 0, "mp3 play sound/%s" , g_launch)
	
public countdown(id)
{
	if(!countdownon)
	{ 		
		timer = 60
		countdownon = true 
		countdown_start(id) 
		
		client_print(0,print_chat,"[ATTENTION] Server Restart in 60 seconds")
		client_print(0,print_chat,"[WARNING] Nuclear Missile has been launched !")

		set_task(0.1, "rocket_sound",0)
		set_task(0.1, "launch_sound",0)
		set_task(54.0, "shake_end",0)
		screen()
		add_nuke(id)
	}
	else
	{
		client_print(id, print_chat, "Restart is already running!") 
	}
}

public countdown_start(id)
{
	if(timer >= 0) 
	{
		if(timer == 0) 
		{
			countdownon = false 
			server_cmd("reload")
		}
		
		set_hudmessage(255,255,255,0.75,0.08,0, 1.0, 1.0) 
		show_hudmessage(0,"Server Restart^n    [ 00:%i ]   ^n",timer)

		timer-- 
		set_task(1.0, "countdown_start") 
	}
	
	if(timer <= 10) 
	{
		
		set_hudmessage(0, 255, 0, -1.0, 0.30, 0, 1.0, 1.0) 
		show_hudmessage(0, "Server Restart^n<-- in %i seconds -->", timer) 
		
		
	}
	
	if(timer == 59)
	{
		// Warning sound on countdown start
		// set_task(0.0, "sound_warn")
		// set_task(1.0, "sound_warn")
		// set_task(3.0, "sound_attention")
	}
	
	if(timer == 20)
	{
		// Sound (20 seconds)
		// set_task(0.0, "countzvukmuz")
	}
	
	if(timer == 10)
	{
		// Sound (10 seconds)
		// set_task(0.0, "countzvukmuz")
	}
	
	if(timer == 3)
	{
		// Siren Sound
		client_cmd(0, "spk %s",g_siren)
	}
	if(timer <= 5)
	{
		// Sound (5,4,3...)
		set_task(0.0, "countzvukzena")
	}
	if(timer >= 10)
	{
		// Launch Detected HUD Message
		detected()
	}
	return PLUGIN_CONTINUE
}

public countdown2(id)
{
	if(!countdownon)
	{ 
		timer = 60
		countdownon = true 
		countdown_start2() 
		
		client_print(0,print_chat,"[ATTENTION] Test Launch !")
		client_print(0,print_chat,"[WARNING] Nuclear Missile has been launched !")
		
		set_task(0.1, "rocket_sound",0)
		set_task(0.1, "launch_sound",0)
		set_task(54.0, "shake_end",0)
		screen()
		add_nuke(id)
	}
	else
	{
		client_print(id, print_chat, "Restart is already running") 
	}
}

public countdown_start2()
{
	if(timer >= 0) 
	{
		if(timer == 0) 
		{
			countdownon = false 
			client_cmd(0,"spk ^"vox/alert _comma _comma atomic weapon detected^"")	
		}
		
		set_hudmessage(255,255,255,0.75,0.08,0, 1.0, 1.0) 
		show_hudmessage(0,"  Test Launch^n    [ 00:%i ]   ^n",timer)

		
		timer-- 
		set_task(1.0, "countdown_start2") 
	}
	
	if(timer <= 10) 
	{
		set_hudmessage(0, 255, 0, -1.0, 0.30, 0, 1.0, 1.0) 
		show_hudmessage(0, "Nuke Impact^n<-- in %i seconds -->", timer) 
	}
	if(timer == 3)
	{
		// Siren Sound
		client_cmd(0, "spk %s",g_siren)
	}
	if(timer <= 5)
	{
		// Sound (5,4,3 ..)
		set_task(0.0, "countzvukzena")
	}
	if(timer >= 10)
	{
		// Launch Detected HUD Message
		detected2()
	}
	return PLUGIN_CONTINUE
}

// HUD Messgae (Efect 1)
public detected() 
{
	set_hudmessage(100, 100, 0, 0.74, 0.14, 1, 1.0, 1.0) 
	ShowSyncHudMsg( 0, g_synchud, "Launch Detected !" );
	// show_hudmessage(0,"Launch Detected !^n")
}

// HUD Messgae (Efect 2)
public detected2() 
{
	set_hudmessage(100, 100, 0, 0.74, 0.14, 2, 1.0, 1.0) 
	ShowSyncHudMsg( 0, g_synchud, "Launch Detected !" );
}

public countzvukzena() 
{
	static szNum[32]
	num_to_word(timer, szNum, 31)
	client_cmd(0,"speak ^"fvox/%s^"", szNum)
}

public countzvukmuz() 
{
	static szNum[32]
	num_to_word(timer, szNum, 31)
	client_cmd(0,"speak ^"vox/%s^"", szNum)
}

public sound_attention() 
{
	client_cmd(0, "spk %s", attention )
}

public sound_warn() 
{
	client_cmd(0, "spk %s", warn )
}


// Nuke Effects
public nuke_explosion(parm[3])
{
	if(!is_valid_ent(parm[0])) return PLUGIN_CONTINUE;
	
	new origin[3],center[3],axis[3],middle[3],radius;
	static Float:vector[3];
	

	
	entity_get_vector(parm[0],EV_VEC_origin,vector);
	origin[0] = floatround(vector[0]);
	origin[1] = floatround(vector[1]);
	origin[2] = floatround(vector[2]) + 50; 
	
	center[0]=origin[0];
	center[1]=origin[1];
	center[2]=origin[2]-16;
	
	axis[0]=origin[0]+radius/3;
	axis[1]=origin[1]+radius/3;
	axis[2]=origin[2]+300; 
	
	//Shockwave
	create_cylinder(origin,center,axis,g_shockwave,0,0,10,100,5,255,255,255,255,5);
	create_cylinder(origin,center,axis,g_shockwave,0,0,10,50,5,255,255,255,255,0);
	
	create_cylinder(origin,center,axis,g_streak,0,0,12,500,10,255,255,100,255,0);
	create_hexplo_effect(origin);
	
	// create_te_dlight(origin,radius,255,255,100,30,60);
	
	center[2] += 20;
	
	middle[0] = origin[0]+radius/8;
	middle[1] = origin[1]+radius/8;
	middle[2] = origin[2]+100;
	
	axis[0] += 400;
	axis[1] += 400;
	
	
	//Explosion effect
	create_explosion_effect(middle);
	create_smoke(center,g_smoke,100,4);
	
	radius = 400;
	new players[MAXPLAYERS],victim,origin_victim[3]
	static num;
	
	get_players(players,num,"ah");
	for(new i = 0; i < num; i++)
	{
		victim = players[i];
		
		get_user_origin(victim,origin_victim);
		
		create_fade(victim,(1<<10)*2,(1<<10),(1<<12),255,255,255,200);
		create_shake(victim,(255<<14),(4<<10),(255<<14));
		
		
		
	}
	
	
	//Radioactive effect
	radius = 1000;
	create_light(origin,radius,0,255,0,100,10);
	
	remove_entity(parm[0]);
	
	return PLUGIN_CONTINUE;
}


// Nuke bomb entity from Nuke Bombs, Green Target Sprite
public add_nuke(id)
{	
	new Float:vector[3];
	new Float:vecMin[3], Float:vecMax[3]
	
	static Float:colors[3],timer;
	timer = 56
	
	entity_get_vector(id,EV_VEC_origin,vector);
	
	new ent = create_entity("cycler_sprite");
	
	entity_set_string(ent,EV_SZ_classname,"item_nuke");
	entity_set_model(ent,"sprites/bflare.spr");
	
	vector[2] += 10.0;
	entity_set_origin(ent,vector);
	entity_set_int(ent,EV_INT_rendermode,kRenderTransAdd);
	entity_set_int(ent,EV_INT_renderfx,kRenderFxGlowShell);
	entity_set_int(ent,EV_INT_movetype,MOVETYPE_TOSS);
	entity_set_int(ent,EV_INT_solid,SOLID_TRIGGER);
	entity_set_size(ent, vecMin, vecMax)
	
	vecMin[0]= 1.0
	vecMin[1]= 1.0
	vecMin[2]= 1.0
	vecMax[0]= 1.0
	vecMax[1]= 1.0
	vecMax[2]= 1.0
	
	colors[0] = 0.0;
	colors[1] = 255.0;
	colors[2] = 0.0;
	
	entity_set_vector(ent,EV_VEC_rendercolor,colors);
	entity_set_float(ent,EV_FL_renderamt,255.0);
	
	drop_to_floor(ent);
	
	new parm[3];
	parm[0] = ent;
	parm[1] = id;
	parm[2] = timer;
	
	set_task(float(timer + 1),"nuke_explosion",TASK_BOMB + ent,parm,3);
	
	
	return PLUGIN_CONTINUE;
}

stock create_cylinder(origin[3],center[3],axis[3],sprite,frame_start,frame_rate,life,width,amplitude,red,green,blue,brightness,speed)
{
	message_begin(MSG_PVS,SVC_TEMPENTITY,origin);
	write_byte(TE_BEAMCYLINDER);
	write_coord(center[0]);
	write_coord(center[1]);
	write_coord(center[2]);
	write_coord(axis[0]);
	write_coord(axis[1]);
	write_coord(axis[2]);
	write_short(sprite);
	write_byte(frame_start);
	write_byte(frame_rate);
	write_byte(life);
	write_byte(width);
	write_byte(amplitude);
	write_byte(red);
	write_byte(green);
	write_byte(blue);
	write_byte(brightness);
	write_byte(speed);
	message_end();
}

stock create_light(origin[3],radius,red,green,blue,life,decay_rate)
{
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
	write_byte(TE_DLIGHT);
	write_coord(origin[0]);
	write_coord(origin[1]);
	write_coord(origin[2]);
	write_byte(radius);
	write_byte(red);
	write_byte(green);
	write_byte(blue);
	write_byte(life);
	write_byte(decay_rate);
	message_end();
}

stock create_explosion_effect(origin[3])
{
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
	write_byte(TE_TAREXPLOSION);
	write_coord(origin[0]);
	write_coord(origin[1]);
	write_coord(origin[2]);
	message_end();
}

stock create_fade(id,duration,holdtime,fadetype,red,green,blue,alpha)
{	
	message_begin(MSG_ONE_UNRELIABLE,g_fade,{0,0,0}, id);
	write_short(duration);
	write_short(holdtime);
	write_short(fadetype);
	write_byte(red);
	write_byte(green);
	write_byte(blue);
	write_byte(alpha);
	message_end();
}

stock create_shake(id,amount,duration,frequency)
{	
	message_begin(MSG_ONE_UNRELIABLE,g_shake,{0,0,0},id);
	write_short(amount);
	write_short(duration);
	write_short(frequency);
	message_end();
}
	
stock create_hexplo_effect(origin[3])
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
	write_byte(TE_SPRITE) 
	write_coord(origin[0]) 
	write_coord(origin[1]) 
	write_coord(origin[2] +400) 
	write_short(g_hexplo) 
	write_byte(150) 
	write_byte(255) 
	message_end();
}

stock create_smoke(origin[3],sprite,scale,frame_rate)
{
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY);
	write_byte(TE_SMOKE);
	write_coord(origin[0]);
	write_coord(origin[1]);
	write_coord(origin[2]);
	write_short(sprite);
	write_byte(scale);
	write_byte(frame_rate);
	message_end();
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1029\\ f0\\ fs16 \n\\ par }
*/
